/*
 * Test zlib inflate_table()
 * by Javantea
 * Sept 26, 2015
 * 
 * Found a bug in my python implementation of zlib.
 * Couldn't get debugging for zlib. 
 * 
 * gcc -o inflate_trees_test1 inflate_trees_test1.c ~/src/zlib-1.2.5/inftrees.c -Wall -ggdb -O0 -I/home/jvoss/src/zlib-1.2.5/
gdb ./inflate_trees_test1
(gdb) break inflate_table
Breakpoint 1 at 0x400913: file /home/jvoss/src/zlib-1.2.5/inftrees.c, line 107.
(gdb) run
Starting program: /home/jvoss/recent/pfm/projects/compress/unproprietary/inflate_trees_test1 
inflate:       table sizes ok

Breakpoint 1, inflate_table (type=CODES, lens=0x7fffffffb790, codes=19, table=0x7fffffffb788, bits=0x7fffffffb770, 
    work=0x7fffffffba10) at /home/jvoss/src/zlib-1.2.5/inftrees.c:107
107         for (len = 0; len <= MAXBITS; len++)
(gdb) print lens[0]
$1 = 5
(gdb) c
Continuing.
invalid code lengths set
[Inferior 1 (process 9572) exited with code 01]


*/
#include <zlib.h>
#include "zutil.h"
#include "inftrees.h"
#include "inflate.h"
#include <stdio.h>

int main(int argc, char **argv)
{
	struct inflate_state sto;
	struct inflate_state *state = &sto;
    static const unsigned short order[19] = /* permutation of code lengths */
        {16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15};

	state->nlen = 278; //BITS(5) + 257;
	state->ndist = 26; //BITS(5) + 1;
	state->ncode =  6; //BITS(4) + 4;
	fprintf(stderr, "inflate:       table sizes ok\n");
	state->have = 0;
	state->mode = LENLENS;
	//case LENLENS:
	unsigned short x[] = {4, 0, 0, 5, 2, 3, 3, 3, 3, 4, 0, 0, 0, 0, 0, 0, 6, 6, 4};
	memcpy(state->lens, x, sizeof(x));
	state->have = 6;
	//while (state->have < state->ncode) {
	//	state->lens[order[state->have++]] = (unsigned short)BITS(3);
	//}
	while (state->have < 19)
		state->lens[order[state->have++]] = 0;
	state->next = state->codes;
	state->lencode = (code const FAR *)(state->next);
	state->lenbits = 7;
	int ret = inflate_table(CODES, state->lens, 19, &(state->next),
						&(state->lenbits), state->work);
	if (ret) {
		printf("invalid code lengths set\n");
		return 1;
	}
	fprintf(stderr, "inflate:       code lengths ok\n");
	state->have = 0;
	state->mode = CODELENS;
	return 0;
}
